/*
 Copyright (C) 2011 Nicholas Peterson. All rights reserved.
 
 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:
 
 * Redistributions of source code must retain the above copyright notice, this
 list of conditions and the following disclaimer.
 
 * Redistributions in binary form must reproduce the above copyright notice,
 this list of conditions and the following disclaimer in the documentation
 and/or other materials provided with the distribution.
 
 * Neither the name of the author nor the names of its contributors may be used
 to endorse or promote products derived from this software without specific
 prior written permission.
 
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
 FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
#import "RPAsyncServerViewController.h"

@implementation RPAsyncServerViewController

- (void)dealloc
{
    [loadInd release];
    [responseArea release];
    [super dealloc];
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

/*
// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad
{
    [super viewDidLoad];
}
*/
-(IBAction)failButtonTapped{
    [failInd startAnimating];
    [[DemoServer sharedServer] getFailWhaleWithConsumer:self];
}
-(IBAction)CERNButtonTapped{
    [loadInd startAnimating];
    [[DemoServer sharedServer] getTweetsFromUser:@"CERN" consumer:self];
}
- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}
-(void)stopIndicators{
    [loadInd stopAnimating];
    [failInd stopAnimating];
}
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
-(void)rpConnection:(RPURLConnection *)connection didFailWithError:(NSError *)error{
    [self stopIndicators];
    //The cake was a lie :_(
    NSLog(@"did fail with error: %@", error);
}
-(void)rpConnection:(RPURLConnection *)connection didFinishWithInfo:(NSDictionary *)info{
     [self stopIndicators];
    [responseArea flashScrollIndicators];
    //LIES!
    if ([connection.response statusCode] >= 400) {
        responseArea.textColor = [UIColor redColor];
        responseArea.font = [UIFont boldSystemFontOfSize:12];
        responseArea.text = [info description];
        return;
    }
    
    /* Cake!!!
     _..--'''@   @'''--.._
     .'   @_/-//-\/>/>'/ @  '.
     (  @  /_<//<'/----------^-)
     |'._  @     //|###########|
     |~  ''--..@|',|}}}}}}}}}}}|
     |  ~   ~   |/ |###########|
     | ~~  ~   ~|./|{{{{{{{{{{{|
     '._ ~ ~ ~ |,/`````````````
        ''--.~.|/
     */
    responseArea.text = [info description];
    responseArea.textColor = [UIColor blackColor];
    responseArea.font = [UIFont systemFontOfSize:12];
}
@end
